package net.nevet5gi.buzzbot.commands;

import net.nevet5gi.buzzbot.BuzzBot;
import net.nevet5gi.buzzbot.commands.utils.CommandContext;
import net.nevet5gi.buzzbot.commands.utils.ICommand;
import net.nevet5gi.buzzbot.database.SqlDB;
import net.nevet5gi.buzzbot.objects.BanData;

import java.util.List;

public class BanCmd implements ICommand {
    @Override
    public void handle(CommandContext ctx) {
        //TODO Add checks for commands so they dont break the bot
        //TODO Get username and discriminator of person banned and mod
        //TODO DM Person who was banned with info about ban
        //TODO Make bans able to be modified by original banner only

        List<String> args = ctx.getArgs();

        if (args.size() < 3) {
            ctx.getChannel().sendMessage("Not enough arguments, please try again").queue();
            return;
        }

        BanData ban = new BanData();

        if (args.get(0).contains("<@")) {
            ban.setUserId(Long.parseLong(args.get(0).replace("<","").replace("@","").replace("&","").replace(">","")));
        } else {
            ban.setUserId(Long.parseLong(args.get(0)));
        }

        if (args.get(1).contains("perm")) {
            ban.setBanLength(0);
            ban.setBanType(true);
        } else if (args.get(1).contains("h")) {
            ban.setBanLength(Integer.parseInt(args.get(1).replace("h","")));
            ban.setBanType(false);
        } else if (args.get(1).contains("d")) {
            ban.setBanLength(Integer.parseInt(args.get(1).replace("d","")) * 24);
            ban.setBanType(false);
        } else if (args.get(1).contains("w")) {
            ban.setBanLength(Integer.parseInt(args.get(1).replace("w","")) * 24 * 7);
            ban.setBanType(false);
        } else if (args.get(1).contains("m")) {
            ban.setBanLength(Integer.parseInt(args.get(1).replace("m", "")) * 24 * 30);
            ban.setBanType(false);
        } else if (args.get(1).contains("y")) {
            ban.setBanLength(Integer.parseInt(args.get(1).replace("y","")) * 24 * 365);
            ban.setBanType(false);
        } else {
            ctx.getChannel().sendMessage("Invalid time argument, please try again").queue();
            return;
        }

        StringBuilder sb = new StringBuilder();
        if (args.size() >= 2) {
            for (int i = 2; i < args.size(); i++) {
                sb.append(args.get(i));
                sb.append(" ");
            }
        }
        ban.setReason(sb.toString().trim());

        if (ban.getBanLength() == 0) {
            ctx.getChannel().sendMessage("<@" + ctx.getMessage().getAuthor().getId() + "> permanently banned <@" + ban.getUserId() + ">. Reason: " + ban.getReason()).queue();
        } else {
            ctx.getChannel().sendMessage("<@" + ctx.getMessage().getAuthor().getId() + "> banned <@" + ban.getUserId() + "> for " + ban.getBanLength() + " hours. Reason: " + ban.getReason()).queue();
        }

        BuzzBot.jda.retrieveUserById(ban.getUserId()).queue(user -> { ban.setUserName(user.getName()); });
        ban.setModId(ctx.getMessage().getAuthor().getIdLong());
        ban.setModName(ctx.getMessage().getAuthor().getName());
        ban.setServerId(ctx.getGuild().getIdLong());
        ban.setServerName(ctx.getGuild().getName());

        SqlDB sql = new SqlDB();
        sql.insertBan(ban, "master_ban_record");
        sql.close();

        //ctx.getEvent().getGuild().ban(cmdf, 1 , "").submit();
        //ctx.getMessage().reply("yes ban");
    }

    @Override
    public String getName() {
        return "ban";
    }

    @Override
    public int getPermissionLevel() {
        return 3;
    }

    @Override
    public String getHelp() {
        return "Bans the specified user";
    }
}
