package net.nevet5gi.buzzbot.commands;


import com.google.gson.Gson;
import com.google.gson.JsonElement;
import net.dv8tion.jda.api.EmbedBuilder;
import net.dv8tion.jda.api.interactions.commands.build.CommandData;
import net.nevet5gi.buzzbot.Config;
import net.nevet5gi.buzzbot.commands.utils.CommandContext;
import net.nevet5gi.buzzbot.commands.utils.ICommand;
import net.nevet5gi.buzzbot.commands.utils.ISlashCommand;

import java.io.IOException;
import java.net.URI;
import java.net.http.HttpClient;
import java.net.http.HttpRequest;
import java.net.http.HttpResponse;

public class BeeCmd implements ICommand, ISlashCommand {
    public static String url;
    @Override
    public void handle(CommandContext ctx) {
        try { getHttpConnection(); } catch (IOException | InterruptedException e) { e.printStackTrace(); }
        EmbedBuilder eb = new EmbedBuilder();
        eb.setImage(url.replace("\"",""));
        ctx.getChannel().sendMessageEmbeds(eb.build()).queue();
    }

    @Override
    public String getName() {
        return "bee";
    }

    @Override
    public String getHelp() {
        return "Sends a picture of a bee!\n" +
                "Usage: `" + Config.getConfig().getString("bot.prefix") + "bee`";
    }

    public static void getHttpConnection() throws IOException, InterruptedException {
        HttpClient client = HttpClient.newHttpClient();
        HttpRequest request = HttpRequest.newBuilder()
                .GET()
                .header("accept", "application/json")
                .uri(URI.create("https://api.nevets.tech/bee"))
                .build();
        client.sendAsync(request, HttpResponse.BodyHandlers.ofString())
                .thenApply(HttpResponse::body)
                .thenApply(BeeCmd::parse)
                .join();
    }

    public static String parse(String response) {
        JsonElement je = new Gson().fromJson(response, JsonElement.class);
        url = je.getAsJsonObject().get("link").toString();

        return null;
    }

    @Override
    public void handleSlash(CommandContext ctx) {
        try { getHttpConnection(); } catch (IOException | InterruptedException e) { e.printStackTrace(); }
        EmbedBuilder eb = new EmbedBuilder();
        eb.setImage(url.replace("\"",""));
        ctx.getHook().sendMessageEmbeds(eb.build()).queue();
    }

    @Override
    public String getDescription() {
        return "Responds with a picture of a bee!";
    }

    @Override
    public CommandData getCommandData() {
        return new CommandData(this.getName(), this.getDescription());
    }
}
