package net.nevet5gi.buzzbot.commands;

import net.dv8tion.jda.api.entities.IMentionable;
import net.dv8tion.jda.api.interactions.commands.OptionType;
import net.dv8tion.jda.api.interactions.commands.build.CommandData;
import net.nevet5gi.buzzbot.commands.utils.CommandContext;
import net.nevet5gi.buzzbot.commands.utils.ICommand;
import net.nevet5gi.buzzbot.commands.utils.ISlashCommand;

public class TestCmd implements ICommand, ISlashCommand {
    @Override
    public void handle(CommandContext ctx) {
        ctx.getMessage().reply("test command").queue();
    }

    @Override
    public void handleSlash(CommandContext ctx) {
        long number = ctx.getSlashEvent().getOption("number").getAsLong();
        IMentionable member = ctx.getSlashEvent().getOption("mention").getAsMentionable();
        boolean testBoolean = ctx.getSlashEvent().getOption("boolean").getAsBoolean();
        String commandString = ctx.getSlashEvent().getCommandString();

        String content = "number: " + number + ", mention: " + member.getAsMention() + ", boolean: " + testBoolean + ", command string: " + commandString;

        ctx.getHook().sendMessage(content).queue();
    }

    @Override
    public String getDescription() {
        return "Checks the ping between bot and API";
    }

    @Override
    public CommandData getCommandData() {
        return new CommandData(this.getName(), this.getDescription())
                .addOption(OptionType.INTEGER, "number", "test number", true)
                .addOption(OptionType.USER, "mention", "mentioned member or role", true)
                .addOption(OptionType.BOOLEAN, "boolean", "test boolean", true);
    }

    @Override
    public String getName() {
        return "test";
    }


    @Override
    public String getHelp() {
        return "tests api ping";
    }
}
